import { Registry } from '@nocobase/utils/client';
import React from 'react';
import { RadioWithTooltip } from '../components/RadioWithTooltip';
import { useWorkflowVariableOptions } from '../variable';
interface Calculator {
    name: string;
    type: 'boolean' | 'number' | 'string' | 'date' | 'unknown' | 'null' | 'array';
    group: string;
}
export declare const calculators: Registry<Calculator>;
declare function CalculationConfig({ value, onChange }: {
    value: any;
    onChange: any;
}): React.JSX.Element;
declare const _default: {
    title: string;
    type: string;
    group: string;
    description: string;
    fieldset: {
        rejectOnFalse: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                disabled: boolean;
            };
            enum: {
                value: boolean;
                label: string;
            }[];
        };
        engine: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                options: [string, import("@nocobase/evaluators/client").Evaluator] | (string | {
                    label: string;
                })[];
            };
            required: boolean;
            default: string;
        };
        calculation: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            };
            required: boolean;
        };
        expression: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                scope: string;
            };
            "x-validator"(value: any, rules: any, { form }: {
                form: any;
            }): string;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                    schema: {
                        description: string;
                    };
                };
            };
            required: boolean;
        };
    };
    view: {};
    options: {
        label: string;
        key: string;
        value: {
            rejectOnFalse: boolean;
        };
    }[];
    component: ({ data }: {
        data: any;
    }) => React.JSX.Element;
    scope: {
        renderEngineReference: (key: string) => React.JSX.Element;
        useWorkflowVariableOptions: typeof useWorkflowVariableOptions;
    };
    components: {
        CalculationConfig: typeof CalculationConfig;
        RadioWithTooltip: typeof RadioWithTooltip;
    };
};
export default _default;
