"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.calculators = void 0;
function _icons() {
  const data = require("@ant-design/icons");
  _icons = function _icons() {
    return data;
  };
  return data;
}
function _css() {
  const data = require("@emotion/css");
  _css = function _css() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
function _client2() {
  const data = require("@nocobase/evaluators/client");
  _client2 = function _client2() {
    return data;
  };
  return data;
}
function _client3() {
  const data = require("@nocobase/utils/client");
  _client3 = function _client3() {
    return data;
  };
  return data;
}
function _antd() {
  const data = require("antd");
  _antd = function _antd() {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _reactI18next() {
  const data = require("react-i18next");
  _reactI18next = function _reactI18next() {
    return data;
  };
  return data;
}
var _ = require(".");
var _Branch = require("../Branch");
var _FlowContext = require("../FlowContext");
var _RadioWithTooltip = require("../components/RadioWithTooltip");
var _renderEngineReference = require("../components/renderEngineReference");
var _locale = require("../locale");
var _style = require("../style");
var _variable = require("../variable");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
const calculators = new (_client3().Registry)();
exports.calculators = calculators;
calculators.register('equal', {
  name: '=',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('notEqual', {
  name: '≠',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('gt', {
  name: '>',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('gte', {
  name: '≥',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('lt', {
  name: '<',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('lte', {
  name: '≤',
  type: 'boolean',
  group: 'boolean'
});
calculators.register('add', {
  name: '+',
  type: 'number',
  group: 'number'
});
calculators.register('minus', {
  name: '-',
  type: 'number',
  group: 'number'
});
calculators.register('multiple', {
  name: '*',
  type: 'number',
  group: 'number'
});
calculators.register('divide', {
  name: '/',
  type: 'number',
  group: 'number'
});
calculators.register('mod', {
  name: '%',
  type: 'number',
  group: 'number'
});
calculators.register('includes', {
  name: '{{t("contains")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('notIncludes', {
  name: '{{t("does not contain")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('startsWith', {
  name: '{{t("starts with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('notStartsWith', {
  name: '{{t("not starts with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('endsWith', {
  name: '{{t("ends with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('notEndsWith', {
  name: '{{t("not ends with")}}',
  type: 'boolean',
  group: 'string'
});
calculators.register('concat', {
  name: `{{t("concat", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'string',
  group: 'string'
});
const calculatorGroups = [{
  value: 'boolean',
  title: '{{t("Comparision")}}'
}, {
  value: 'number',
  title: `{{t("Arithmetic calculation", { ns: "${_locale.NAMESPACE}" })}}`
}, {
  value: 'string',
  title: `{{t("String operation", { ns: "${_locale.NAMESPACE}" })}}`
}, {
  value: 'date',
  title: `{{t("Date", { ns: "${_locale.NAMESPACE}" })}}`
}];
function getGroupCalculators(group) {
  return Array.from(calculators.getEntities()).filter(([key, value]) => value.group === group);
}
function Calculation({
  calculator,
  operands = [],
  onChange: _onChange
}) {
  const compile = (0, _client().useCompile)();
  const options = (0, _variable.useWorkflowVariableOptions)();
  return _react().default.createElement("fieldset", {
    className: (0, _css().css)`
        display: flex;
        gap: 0.5em;
        align-items: center;
        flex-wrap: wrap;
      `
  }, _react().default.createElement(_client().Variable.Input, {
    value: operands[0],
    onChange: v => _onChange({
      calculator,
      operands: [v, operands[1]]
    }),
    scope: options,
    useTypedConstant: true
  }), _react().default.createElement(_antd().Select, {
    value: calculator,
    onChange: v => _onChange({
      operands,
      calculator: v
    }),
    placeholder: (0, _locale.lang)('Calculator'),
    dropdownMatchSelectWidth: false
  }, calculatorGroups.filter(group => Boolean(getGroupCalculators(group.value).length)).map(group => _react().default.createElement(_antd().Select.OptGroup, {
    key: group.value,
    label: compile(group.title)
  }, getGroupCalculators(group.value).map(([value, {
    name
  }]) => _react().default.createElement(_antd().Select.Option, {
    key: value,
    value: value
  }, compile(name)))))), _react().default.createElement(_client().Variable.Input, {
    value: operands[1],
    onChange: v => _onChange({
      calculator,
      operands: [operands[0], v]
    }),
    scope: options,
    useTypedConstant: true
  }));
}
function CalculationItem({
  value,
  onChange: _onChange2,
  onRemove
}) {
  if (!value) {
    return null;
  }
  const calculator = value.calculator,
    _value$operands = value.operands,
    operands = _value$operands === void 0 ? [] : _value$operands;
  return _react().default.createElement("div", {
    className: (0, _css().css)`
        display: flex;
        position: relative;
        margin: 0.5em 0;
      `
  }, value.group ? _react().default.createElement(CalculationGroup, {
    value: value.group,
    onChange: group => _onChange2(_objectSpread(_objectSpread({}, value), {}, {
      group
    }))
  }) : _react().default.createElement(Calculation, {
    operands: operands,
    calculator: calculator,
    onChange: _onChange2
  }), _react().default.createElement(_antd().Button, {
    onClick: onRemove,
    type: "link",
    icon: _react().default.createElement(_icons().CloseCircleOutlined, null)
  }));
}
function CalculationGroup({
  value,
  onChange: _onChange3
}) {
  const _useTranslation = (0, _reactI18next().useTranslation)(),
    t = _useTranslation.t;
  const _value$type = value.type,
    type = _value$type === void 0 ? 'and' : _value$type,
    _value$calculations = value.calculations,
    calculations = _value$calculations === void 0 ? [] : _value$calculations;
  function onAddSingle() {
    _onChange3(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations, {
        not: false,
        calculator: 'equal'
      }]
    }));
  }
  function onAddGroup() {
    _onChange3(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations, {
        not: false,
        group: {
          type: 'and',
          calculations: []
        }
      }]
    }));
  }
  function _onRemove(i) {
    calculations.splice(i, 1);
    _onChange3(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations]
    }));
  }
  function onItemChange(i, v) {
    calculations.splice(i, 1, v);
    _onChange3(_objectSpread(_objectSpread({}, value), {}, {
      calculations: [...calculations]
    }));
  }
  return _react().default.createElement("div", {
    className: (0, _css().cx)('node-type-condition-group', (0, _css().css)`
          position: relative;
          width: 100%;
          .node-type-condition-group {
            padding: 0.5em 1em;
            border: 1px dashed #ddd;
          }
          + button {
            position: absolute;
            right: 0;
          }
        `)
  }, _react().default.createElement("div", {
    className: (0, _css().css)`
          display: flex;
          align-items: center;
          gap: 0.5em;
          .ant-select {
            width: auto;
            min-width: 6em;
          }
        `
  }, _react().default.createElement(_reactI18next().Trans, null, 'Meet ', _react().default.createElement(_antd().Select, {
    value: type,
    onChange: t => _onChange3(_objectSpread(_objectSpread({}, value), {}, {
      type: t
    }))
  }, _react().default.createElement(_antd().Select.Option, {
    value: "and"
  }, "All"), _react().default.createElement(_antd().Select.Option, {
    value: "or"
  }, "Any")), ' conditions in the group')), _react().default.createElement("div", {
    className: "calculation-items"
  }, calculations.map((calculation, i) => _react().default.createElement(CalculationItem, {
    key: `${calculation.calculator}_${i}`,
    value: calculation,
    onChange: onItemChange.bind(this, i),
    onRemove: () => _onRemove(i)
  }))), _react().default.createElement("div", {
    className: (0, _css().css)`
          button {
            padding: 0;
            &:not(:last-child) {
              margin-right: 1em;
            }
          }
        `
  }, _react().default.createElement(_antd().Button, {
    type: "link",
    onClick: onAddSingle
  }, t('Add condition')), _react().default.createElement(_antd().Button, {
    type: "link",
    onClick: onAddGroup
  }, t('Add condition group'))));
}
function CalculationConfig({
  value,
  onChange: _onChange4
}) {
  const rule = value && Object.keys(value).length ? value : {
    group: {
      type: 'and',
      calculations: []
    }
  };
  return _react().default.createElement(CalculationGroup, {
    value: rule.group,
    onChange: group => _onChange4(_objectSpread(_objectSpread({}, rule), {}, {
      group
    }))
  });
}
var _default = {
  title: `{{t("Condition", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'condition',
  group: 'control',
  description: `{{t('Based on boolean result of the calculation to determine whether to "continue" or "exit" the process, or continue on different branches of "yes" and "no".', { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    rejectOnFalse: {
      type: 'boolean',
      title: `{{t("Mode", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Radio.Group',
      'x-component-props': {
        disabled: true
      },
      enum: [{
        value: true,
        label: `{{t('Continue when "Yes"', { ns: "${_locale.NAMESPACE}" })}}`
      }, {
        value: false,
        label: `{{t('Branch into "Yes" and "No"', { ns: "${_locale.NAMESPACE}" })}}`
      }]
    },
    engine: {
      type: 'string',
      title: `{{t("Calculation engine", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'RadioWithTooltip',
      'x-component-props': {
        options: [['basic', {
          label: `{{t("Basic", { ns: "${_locale.NAMESPACE}" })}}`
        }], ...Array.from(_client2().evaluators.getEntities())].reduce((result, [value, options]) => result.concat(_objectSpread({
          value
        }, options)), [])
      },
      required: true,
      default: 'basic'
    },
    calculation: {
      type: 'string',
      title: `{{t("Condition", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'CalculationConfig',
      'x-reactions': {
        dependencies: ['engine'],
        fulfill: {
          state: {
            visible: '{{$deps[0] === "basic"}}'
          }
        }
      },
      required: true
    },
    expression: {
      type: 'string',
      title: `{{t("Condition expression", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Variable.TextArea',
      'x-component-props': {
        scope: '{{useWorkflowVariableOptions}}'
      },
      ['x-validator'](value, rules, {
        form
      }) {
        const values = form.values;
        const _evaluators$get = _client2().evaluators.get(values.engine),
          evaluate = _evaluators$get.evaluate;
        const exp = value.trim().replace(/{{([^{}]+)}}/g, ' 1 ');
        try {
          evaluate(exp);
          return '';
        } catch (e) {
          return (0, _locale.lang)('Expression syntax error');
        }
      },
      'x-reactions': {
        dependencies: ['engine'],
        fulfill: {
          state: {
            visible: '{{$deps[0] !== "basic"}}'
          },
          schema: {
            description: '{{renderEngineReference($deps[0])}}'
          }
        }
      },
      required: true
    }
  },
  view: {},
  options: [{
    label: `{{t('Continue when "Yes"', { ns: "${_locale.NAMESPACE}" })}}`,
    key: 'rejectOnFalse',
    value: {
      rejectOnFalse: true
    }
  }, {
    label: `{{t('Branch into "Yes" and "No"', { ns: "${_locale.NAMESPACE}" })}}`,
    key: 'branch',
    value: {
      rejectOnFalse: false
    }
  }],
  component: function Component({
    data
  }) {
    const _useTranslation2 = (0, _reactI18next().useTranslation)(),
      t = _useTranslation2.t;
    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
      nodes = _useFlowContext.nodes;
    const id = data.id,
      rejectOnFalse = data.config.rejectOnFalse;
    const trueEntry = nodes.find(item => item.upstreamId === id && item.branchIndex === 1);
    const falseEntry = nodes.find(item => item.upstreamId === id && item.branchIndex === 0);
    return _react().default.createElement(_.NodeDefaultView, {
      data: data
    }, rejectOnFalse ? null : _react().default.createElement("div", {
      className: (0, _css().cx)(_style.nodeSubtreeClass)
    }, _react().default.createElement("div", {
      className: (0, _css().cx)(_style.branchBlockClass, (0, _css().css)`
                  > * > .workflow-branch-lines {
                    > button {
                      display: none;
                    }
                  }
                `)
    }, _react().default.createElement(_Branch.Branch, {
      from: data,
      entry: falseEntry,
      branchIndex: 0
    }), _react().default.createElement(_Branch.Branch, {
      from: data,
      entry: trueEntry,
      branchIndex: 1
    })), _react().default.createElement("div", {
      className: (0, _css().css)`
                position: relative;
                height: 2em;
                overflow: visible;

                > span {
                  position: absolute;
                  top: calc(1.5em - 1px);
                  line-height: 1em;
                  color: #999;
                  background-color: #f0f2f5;
                  padding: 1px;
                }
              `
    }, _react().default.createElement("span", {
      className: (0, _css().css)`
                  right: 4em;
                `
    }, t('No')), _react().default.createElement("span", {
      className: (0, _css().css)`
                  left: 4em;
                `
    }, t('Yes')))));
  },
  scope: {
    renderEngineReference: _renderEngineReference.renderEngineReference,
    useWorkflowVariableOptions: _variable.useWorkflowVariableOptions
  },
  components: {
    CalculationConfig,
    RadioWithTooltip: _RadioWithTooltip.RadioWithTooltip
  }
};
exports.default = _default;