"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScheduleConfig = void 0;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _core() {
  const data = require("@formily/core");
  _core = function _core() {
    return data;
  };
  return data;
}
function _react2() {
  const data = require("@formily/react");
  _react2 = function _react2() {
    return data;
  };
  return data;
}
function _css() {
  const data = require("@emotion/css");
  _css = function _css() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _collection = require("../../schemas/collection");
var _OnField = require("./OnField");
var _EndsByField = require("./EndsByField");
var _RepeatField = require("./RepeatField");
var _constants = require("./constants");
var _locale = require("../../locale");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
const ModeFieldsets = {
  [_constants.SCHEDULE_MODE.STATIC]: {
    startsOn: {
      type: 'datetime',
      title: `{{t("Starts on", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'DatePicker',
      'x-component-props': {
        showTime: true
      },
      required: true
    },
    repeat: {
      type: 'string',
      title: `{{t("Repeat mode", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'RepeatField',
      'x-reactions': [{
        target: 'endsOn',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }, {
        target: 'limit',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }]
    },
    endsOn: {
      type: 'datetime',
      title: `{{t("Ends on", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'DatePicker',
      'x-component-props': {
        showTime: true
      }
    },
    limit: {
      type: 'number',
      title: `{{t("Repeat limit", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'InputNumber',
      'x-component-props': {
        placeholder: `{{t("No limit", { ns: "${_locale.NAMESPACE}" })}}`,
        min: 0
      }
    }
  },
  [_constants.SCHEDULE_MODE.COLLECTION_FIELD]: {
    collection: _objectSpread(_objectSpread({}, _collection.collection), {}, {
      'x-reactions': [..._collection.collection['x-reactions'], {
        // only full path works
        target: 'startsOn',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }]
    }),
    startsOn: {
      type: 'object',
      title: `{{t("Starts on", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'OnField',
      'x-reactions': [{
        target: 'repeat',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }],
      required: true
    },
    repeat: {
      type: 'string',
      title: `{{t("Repeat mode", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'RepeatField',
      'x-reactions': [{
        target: 'endsOn',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }, {
        target: 'limit',
        fulfill: {
          state: {
            visible: '{{!!$self.value}}'
          }
        }
      }]
    },
    endsOn: {
      type: 'object',
      title: `{{t("Ends on", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'EndsByField'
    },
    limit: {
      type: 'number',
      title: `{{t("Repeat limit", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'InputNumber',
      'x-component-props': {
        placeholder: `{{t("No limit", { ns: "${_locale.NAMESPACE}" })}}`,
        min: 0
      }
    },
    appends: _objectSpread(_objectSpread({}, _collection.appends), {}, {
      'x-reactions': [{
        dependencies: ['mode', 'collection'],
        fulfill: {
          state: {
            visible: `{{$deps[0] === ${_constants.SCHEDULE_MODE.COLLECTION_FIELD} && $deps[1]}}`
          }
        }
      }]
    })
  }
};
const scheduleModeOptions = [{
  value: _constants.SCHEDULE_MODE.STATIC,
  label: `{{t("Based on certain date", { ns: "${_locale.NAMESPACE}" })}}`
}, {
  value: _constants.SCHEDULE_MODE.COLLECTION_FIELD,
  label: `{{t("Based on date field of collection", { ns: "${_locale.NAMESPACE}" })}}`
}];
const ScheduleConfig = () => {
  const _useForm = (0, _react2().useForm)(),
    _useForm$values = _useForm.values,
    values = _useForm$values === void 0 ? {} : _useForm$values,
    clearFormGraph = _useForm.clearFormGraph;
  const _useState = (0, _react().useState)(values.mode),
    _useState2 = _slicedToArray(_useState, 2),
    mode = _useState2[0],
    setMode = _useState2[1];
  (0, _react2().useFormEffects)(() => {
    (0, _core().onFieldValueChange)('mode', field => {
      setMode(field.value);
      clearFormGraph('collection');
      clearFormGraph('startsOn');
      clearFormGraph('repeat');
      clearFormGraph('endsOn');
      clearFormGraph('limit');
    });
  });
  return _react().default.createElement(_react().default.Fragment, null, _react().default.createElement(_client().SchemaComponent, {
    schema: {
      type: 'number',
      title: `{{t("Trigger mode", { ns: "${_locale.NAMESPACE}" })}}`,
      name: 'mode',
      'x-decorator': 'FormItem',
      'x-component': 'Radio.Group',
      'x-component-props': {
        options: scheduleModeOptions
      },
      required: true,
      default: _constants.SCHEDULE_MODE.STATIC
    }
  }), _react().default.createElement(_client().SchemaComponent, {
    schema: {
      type: 'void',
      properties: {
        [`mode-${mode}`]: {
          type: 'void',
          'x-component': 'fieldset',
          'x-component-props': {
            className: (0, _css().css)`
                  .ant-input-number {
                    width: 4em;
                  }

                  .ant-picker {
                    width: auto;
                  }
                `
          },
          properties: ModeFieldsets[mode]
        }
      }
    },
    components: {
      OnField: _OnField.OnField,
      RepeatField: _RepeatField.RepeatField,
      EndsByField: _EndsByField.EndsByField
    }
  }));
};
exports.ScheduleConfig = ScheduleConfig;