"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
var _ScheduleConfig = require("./ScheduleConfig");
var _constants = require("./constants");
var _locale = require("../../locale");
var _CollectionBlockInitializer = require("../../components/CollectionBlockInitializer");
var _variable = require("../../variable");
var _FieldsSelect = require("../../components/FieldsSelect");
var _default = {
  title: `{{t("Schedule event", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'schedule',
  fieldset: {
    config: {
      type: 'void',
      'x-component': 'ScheduleConfig',
      'x-component-props': {}
    }
  },
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    ScheduleConfig: _ScheduleConfig.ScheduleConfig,
    FieldsSelect: _FieldsSelect.FieldsSelect
  },
  useVariables(config, {
    types
  }) {
    const _useWorkflowTranslati = (0, _locale.useWorkflowTranslation)(),
      t = _useWorkflowTranslati.t;
    const options = [];
    if (!types || types.includes('date')) {
      options.push({
        key: 'date',
        value: 'date',
        label: t('Trigger time')
      });
    }
    const fieldOptions = (0, _variable.useCollectionFieldOptions)({
      collection: config.collection
    });
    if (config.mode === _constants.SCHEDULE_MODE.COLLECTION_FIELD) {
      if (fieldOptions.length) {
        options.push({
          key: 'data',
          value: 'data',
          label: t('Trigger data'),
          children: fieldOptions
        });
      }
    }
    return options;
  },
  useInitializers(config) {
    if (!config.collection) {
      return null;
    }
    return {
      type: 'item',
      title: `{{t("Trigger data", { ns: "${_locale.NAMESPACE}" })}}`,
      component: _CollectionBlockInitializer.CollectionBlockInitializer,
      collection: config.collection,
      dataSource: '{{$context.data}}'
    };
  },
  initializers: {}
};
exports.default = _default;